package com.nisum.ascend.inventory.controller;

import com.nisum.ascend.inventory.dto.ProductDto;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.nisum.ascend.inventory.service.ProductService;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/api/products")
public class ProductController {
    @Autowired
    ProductService productService;

    @DeleteMapping(value = "/{sku}")
    public Mono<ResponseEntity<Void>> deleteProduct(@PathVariable String sku) {
        return productService.removeProductBySku(sku)
                .map( res -> ResponseEntity.ok().<Void>build())
                .defaultIfEmpty(ResponseEntity.notFound().build());
    }

    @GetMapping()
    public ResponseEntity<Flux<ProductDto>> getAllProducts() {
        return ResponseEntity.ok(productService.findAllProducts());
    }
}
